/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD

  タイトル ： 点光源の設定、
              グーロ、フラットシェーディングの切り替え
              point light,shading mode
  編集履歴 ： 98-04-30 作成開始
              98-06-19 SET5対応
              99-04-05 appends the English comments
************************************************************/

#include <shinobi.h>
#include <njdef.h>
void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}


/* グローバルデータセクション */
/* global data */

#define MATRIX_DEPTH    12
#define VERTEX_MAX      1024

extern NJS_CNK_OBJECT object_cube_root[];

/* 3D関連データ */
/* 3D data */
static NJS_MATRIX     *g_Matrix;   /* マトリクススタック */
                                   /* matrix stack */
static NJS_VERTEX_BUF *g_VBuf;     /* 頂点バッファ */
                                   /* vertex buffer */

static NJS_VIEW    g_View;         /* 視点 */
                                   /* view point */
static NJS_LIGHT   g_Light;        /* 光源 */
                                   /* light source */

/* ポーズ時処理関数 */
/* puase function */
void PausePhase(void);

/* アクティブ時処理関数 */
/* main function */
void ActivePhase(void);

/* ポーズ判定フラグ */
/* pause flag */
Bool g_bPause = FALSE;


/**************************************************************************

	njSetBorderColor( 0x00000000 );
    njUserInit --- Ninjaシステム初期化関数
                   initialize
**************************************************************************/

void njUserInit(void)
{
    /* 画面モード設定 */
    /* Initializes the Dreamcast H/W and readies the SEGA library */
    sbInitSystem( NJD_RESOLUTION_640x240_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* 画面のアスペクト比を変更 */
	/* corrects the screen aspect ratio */
    njSetAspect(1.0F, 0.45F);

    /* メモリの割り当て */
    /* allocates the memory */
    g_Matrix = (NJS_MATRIX *)syMalloc(sizeof(NJS_MATRIX) * MATRIX_DEPTH);
    g_VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * VERTEX_MAX);

    /* 頂点バッファの確保 */
    /* allocates the buffers for registration of vertex data */
    njInitVertexBuffer(VERTEX_MAX * 64 / 4, 0, VERTEX_MAX * 64, 0, 0); 
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );

    /* マトリクススタックの初期化 */
  	/* initializes the matrix stack */
    njInitMatrix(g_Matrix, MATRIX_DEPTH, 1);

    /* 演算用頂点バッファの確保 */
    /* initializes 3D system  */ 
    njInit3D(g_VBuf, VERTEX_MAX);

    /* ビューの初期化 */
    /* initializes the user-defined view */
    njInitView(&g_View);
    njSetView(&g_View);

    /* ライトの初期化 */
    /* initializes the light source  */
    njCreateLight(&g_Light, NJD_SPEC_POINT);
    njSetLightIntensity(&g_Light, 0.5F, 1.0F, 0.2F);
    njSetLightLocation(&g_Light, 0.0F, 0.0F, -7.0F);

    /* アトリビュートを変更できるようにする */
    /* attributes of the CHUNK model can be changed */
    njControl3D( NJD_CONTROL_3D_CNK_CONSTANT_ATTR );

    /* バックグラウンドのカラーを設定 */
   	/* sets background color */
    njSetBackColor(ARGB(0xff, 0xc0, 0, 0), 
                            ARGB(0xff, 0, 0xc0, 0), ARGB(0xff, 0, 0, 0xc0));
    /* テキストのカラーを指定 */
    /* sets the text color */
    njPrintColor(ARGB(0xff, 0xc0, 0xc0, 0xc0));
}


/**************************************************************************

    njUserMain --- Ninjaシステムメイン処理関数
    main
    
**************************************************************************/

Sint32 njUserMain(void)
{
    NJS_PERIPHERAL *per;

    /* ジョイスティックポート１のペリフェラル情報を取得 */
    /* gets the peripheral information (port A) */
    per = njGetPeripheral(NJD_PORT_A0);    

    /* ボタンが押されたかどうかチェック */
    /* checks the start button */
    if (per->press & NJD_DGT_ST) {
        g_bPause = !g_bPause;
    }

	if (!g_bPause) {
	   	/* アクティブ時処理 */
	   	/* not pause */
		ActivePhase();
	} else {
		/* ポーズ時処理 */
		/* pause */
		PausePhase();
	}

    /* デバッグ情報表示 */
    /* prints the sample program name */
    njPrintC(NJM_LOCATION(23, 4), "Ninja Sample POINT LIGHT");

    return NJD_USER_CONTINUE;
}


/**************************************************************************

    ActivePhase --- アクティブ時処理関数
                    not pause
**************************************************************************/

void ActivePhase(void)
{
    static Angle x_ang = NJM_DEG_ANG(0.0F);
    static Angle y_ang = NJM_DEG_ANG(0.0F);
    static Angle z_ang = NJM_DEG_ANG(0.0F);

    static int time = 0;

    /* 経過時間によりシェーディングを切り替える */
    /* changes the shading mode by the time */
    if (++time > 600) {
        time = 0;
    }
    if (time < 300) {
        njSetConstantAttr( 0xffffffff, NJD_FST_FL );
        njPrintC(NJM_LOCATION(5, 8), "Shading Mode = Flat");
    } else {
        njSetConstantAttr( 0xffffffff, 0);
        njPrintC(NJM_LOCATION(5, 8), "Shading Mode = Gouraud");
    }

    /* マトリクスのクリア */
    /* clears the matrix stack */
    njClearMatrix();

    /* 移動処理 */
    /* translate */
    njTranslate(NULL, 0.0F, 0.0F, -10.0F); 

    /* 回転処理 */
    /* rotates  */
    x_ang += NJM_DEG_ANG(1.0F);
    y_ang += NJM_DEG_ANG(1.0F);
    z_ang += NJM_DEG_ANG(1.0F);
    njRotateXYZ(NULL, x_ang, y_ang, z_ang);

    /* 描画 */
    /* draw */
    njCnkDrawObject(object_cube_root);
}


/**************************************************************************

    PausePhase --- ポーズ時処理関数
                   puase
**************************************************************************/

void PausePhase(void)
{
	static NJS_FOG_TABLE fog;

	/* フォグの設定 */
	/* sets the fog data */
	njSetFogColor(0x00000000);
	njSetFogDensity(0xfff0);
	njGenerateFogTable(fog);
	njSetFogTable(fog);
	njFogEnable();

    /* 描画 */
    /* draws the object */
    njCnkDrawObject(object_cube_root);

	/* フォグを無効にする */
	/* Disables the fog effect  */
	njFogDisable();

    /* ポーズ状態の表示 */
    /* prints the pause status */
    njPrintC(NJM_LOCATION(38, 25), "PAUSE");
}


/**************************************************************************

    njUserExit --- Ninjaシステム終了処理関数

**************************************************************************/

void njUserExit(void)
{
	njExitPrint();
	
    /* メモリの開放 */
   	/* exits texture use  */
    syFree(g_Matrix);
    syFree(g_VBuf);

    /*  システムの終了処理を行います */
    /* exits the system    */
    sbExitSystem();
}
